diff -rNci gcc-2.7.2/flow.c gcc-2.7.2p/flow.c
*** gcc-2.7.2/flow.c	Mon Aug 28 10:23:34 1995
--- gcc-2.7.2p/flow.c	Tue Jan 23 09:35:24 1996
***************
*** 2954,2956 ****
--- 3020,3613 ----
      }
    fprintf (file, "\n");
  }
+ 
+ /* intel1 */
+ /* Information about registers */
+ struct regopt_info
+ {
+   rtx insn_set;			/* If non NULL then the insn that loads the register
+                           with it's current value */
+   int num_uses_copied;		/* To count if the reg setter has been copied to
+                           each of the uses */
+   char copied_for_src;          /* Set per insn if the insn_set has been copied
+                           as a result of analysis on the src */
+ };
+ static struct regopt_info *rinfo;
+ 
+ /* Count the number of new sets of the register */
+ static int *my_reg_n_sets;
+ 
+ /* Count the number of times a register is used in an insn */
+ static int *regs_in_body;
+ 
+ /* Count the number of times a register is used in a function */
+ static int *reg_n_uses;
+ 
+ /* Copied from sched.c
+    Return the INSN_LIST containing INSN in LIST, or NULL
+    if LIST does not contain INSN.  */
+ #ifndef __GNUC__
+ #define __inline
+ #endif
+ 
+ __inline static rtx
+ find_insn_list (insn, list)
+      rtx insn;
+      rtx list;
+ {
+   while (list)
+     {
+       if (XEXP (list, 0) == insn)
+ 	return list;
+       list = XEXP (list, 1);
+     }
+   return 0;
+ }
+ 
+ /*
+   Sometimes cse is done where it is detremental. Consider register 23
+   in the following insn stream:
+ 
+ (insn 18 65 82 (set (reg/v:SI 23)
+         (plus:SI (reg/v:SI 22)
+             (const_int -4501))) 32 {movsi+1} (nil)
+     (nil))
+ 
+ (insn 82 18 83 (set (cc0)
+         (compare:CC (reg/v:SI 22)
+             (const_int 4500))) 6 {cmpsi_cc} (nil)
+     (nil))
+ 
+ (jump_insn 83 82 90 (set (pc)
+         (if_then_else (gt (cc0)
+                 (const_int 0))
+             (label_ref 63)
+             (pc))) 185 {bgt+1} (nil)
+     (nil))
+ 
+ (note 90 83 91 "" NOTE_INSN_DELETED)
+ 
+ (insn 91 90 93 (set (reg:SI 32)
+         (ashift:SI (reg/v:SI 23)
+             (const_int 2))) 136 {ashlsi3} (nil)
+     (expr_list:REG_DEAD (reg/v:SI 23)
+         (nil)))
+ 
+   reg 23 appears in insn 91 as a result of cse, before cse insn 90
+   and 91 were:
+ 
+ (insn 90 83 91 (set (reg:SI 33)
+         (plus:SI (reg/v:SI 22)
+             (const_int -4501))) -1 (nil)
+     (nil))
+ 
+ (insn 91 90 93 (set (reg:SI 34)
+         (ashift:SI (reg:SI 33)
+             (const_int 2))) -1 (nil)
+     (nil))
+ 
+   since reg 23 does not appear anywhere else in the rtl and it is dead
+   at insn 91 it would be better to move insn 18 to after insn 90, thus
+   allowing the combiner to combine insn 18 into 91.
+ 
+ */
+ static void
+ correct_cse_mistakes (f, cur_max_reg, dump_file)
+      rtx f;
+      int cur_max_reg;
+      FILE *dump_file;
+ {
+   rtx insn, src, dest, insn_set, note;
+   struct regs_mentioned *header, *a_reg_used;
+   int num_regs, recog_ok, i, regno;
+   char *storage1, *storage2;
+ 
+   rinfo =
+     (struct regopt_info *) alloca ((cur_max_reg) * sizeof (struct regopt_info));
+   bzero (rinfo, (cur_max_reg) * sizeof (struct regopt_info));
+   reg_n_uses = (int *) alloca ((cur_max_reg) * sizeof (int));
+   bzero (reg_n_uses, (cur_max_reg) * sizeof (int));
+   regs_in_body = (int *) alloca ((cur_max_reg) * sizeof (int));
+   bzero (regs_in_body, (cur_max_reg) * sizeof (int));
+   my_reg_n_sets = (int *) alloca ((cur_max_reg) * sizeof (int));
+   bzero (my_reg_n_sets, (cur_max_reg) * sizeof (int));
+ 
+   if (dump_file)
+     fprintf (dump_file, "\ndoing correct_cse_mistakes:\n\n");
+   insn = f;
+   while (insn)
+     {
+       if (GET_CODE (insn) == INSN || GET_CODE (insn) == JUMP_INSN
+ 	  || GET_CODE (insn) == CALL_INSN)
+ 	{
+ 	  count_reg_uses (PATTERN (insn), reg_n_uses);
+ 	}
+       insn = NEXT_INSN (insn);
+     }
+   insn = f;
+   while (insn)
+     {
+       switch (GET_CODE (insn))
+ 	{
+ 
+ 	case CALL_INSN:
+ 	  /* Don't want to change reg_n_calls_crosses */
+ 	  bzero (rinfo, cur_max_reg * sizeof (struct regopt_info));
+ 	  break;
+ 
+ 	case CODE_LABEL:
+ 	case BARRIER:
+ 	  /* forget everything */
+ 	  bzero (rinfo, cur_max_reg * sizeof (struct regopt_info));
+ 	  break;
+ 
+ 	case INSN:
+           if (GET_CODE (PATTERN (insn)) == CLOBBER)
+             {
+ 	      if (GET_CODE (SET_DEST (PATTERN (insn))) == REG)
+ 		{
+ 		  rinfo[ REGNO (SET_DEST (PATTERN (insn)))].insn_set = NULL;
+ 		  for (i = 0; i < cur_max_reg; i++)
+ 		    {
+ 		      if (rinfo[i].insn_set
+ 			  && reg_overlap_mentioned_p (SET_DEST (PATTERN (insn)), 
+ 			        SET_SRC (PATTERN (rinfo[i].insn_set)))
+ 			)
+ 			{	/* current value of reg dest overwritten */
+ 			  rinfo[i].insn_set = NULL;
+ 			}
+ 		    }
+ 		}
+             }
+ 	  else if (GET_CODE (PATTERN (insn)) == PARALLEL)
+ 	    {
+ 	      for (i = 0; i < XVECLEN (PATTERN (insn), 0); i++)
+ 		{
+ 		  rtx cur_rtx;
+ 		  cur_rtx = XVECEXP (PATTERN (insn), 0, i);
+ 		  if ((GET_CODE (cur_rtx) == SET  
+ 		       || GET_CODE (cur_rtx) == CLOBBER)
+ 		      && GET_CODE (SET_DEST (cur_rtx)) == REG)
+ 		    {
+ 		      rinfo[ REGNO (SET_DEST (cur_rtx))].insn_set = NULL;
+ 		      for (i = 0; i < cur_max_reg; i++)
+ 		        {
+ 		          if (rinfo[i].insn_set
+ 			      && reg_overlap_mentioned_p (SET_DEST (cur_rtx), 
+ 			             SET_SRC (PATTERN (rinfo[i].insn_set)))
+ 			    )
+ 			    {	/* current value of reg dest overwritten */
+ 			      rinfo[i].insn_set = NULL;
+ 			    }
+ 		        }
+ 		    }
+ 		  if (!(GET_CODE (cur_rtx) == SET  
+ 		       || GET_CODE (cur_rtx) == CLOBBER
+ 		       || GET_CODE (cur_rtx) == USE))
+ 	            bzero (rinfo, cur_max_reg * sizeof (struct regopt_info));
+ 		}
+ 	    }
+ 	  else if (GET_CODE (PATTERN (insn)) == SET)
+ 	    {
+ 	      dest = SET_DEST (PATTERN (insn));
+ 	      src = SET_SRC (PATTERN (insn));
+ 	      if (GET_CODE (src) == REG)
+ 		{
+ 		  i = REGNO (src);
+                   if (rinfo[i].insn_set
+                       && BLOCK_NUM (insn) == BLOCK_NUM (rinfo[i].insn_set))
+                     { /* Since insn_set cannot be deleted stop optimization */
+                       rinfo[i].insn_set = NULL;
+                     }
+                 }
+ 	      else /* (GET_CODE (src) != REG) */
+ 		{
+ 	          count_reg_uses (src, regs_in_body);
+ 		  for (i = 0; i < cur_max_reg; i++)
+ 		    {
+                       if (rinfo[i].insn_set
+                           && regs_in_body[i]
+                           && BLOCK_NUM (insn) == BLOCK_NUM (rinfo[i].insn_set))
+                         { /* Since insn_set cannot be deleted stop optimization */
+                           rinfo[i].insn_set = NULL;
+                         }
+ 		      if (reg_n_sets[i] == 1
+ 		          && regs_in_body[i]
+ 			  && rinfo[i].insn_set
+ 			  && GET_CODE (rinfo[i].insn_set) == INSN)
+ 			{	
+ 			  if (find_regno_note (insn, REG_DEAD, i))
+ 			    {
+ 			      /* copy insn_set just prior to insn */
+ 			      do_correction (i, insn, dump_file);
+ 			    }
+ 			  else
+ 			    { /* A use that is not dead - stop.  */
+                               rinfo[i].insn_set = NULL;
+ 			    }
+ 			}
+ 		    }
+ 		  bzero (regs_in_body, cur_max_reg * sizeof (int));
+ 		}
+ 	      if (GET_CODE (dest) != REG)
+ 		{
+ 		  count_reg_uses (dest, regs_in_body);
+ 		  for (i = 0; i < cur_max_reg; i++)
+ 		    {
+                       if (rinfo[i].insn_set
+                           && regs_in_body[i]
+                           && BLOCK_NUM (insn) == BLOCK_NUM (rinfo[i].insn_set))
+                         { /* Since insn_set cannot be deleted stop optimization */
+                           rinfo[i].insn_set = NULL;
+                         }
+ 		      if (reg_n_sets[i] == 1
+ 		          && !rinfo[i].copied_for_src
+ 		          && regs_in_body[i]
+ 			  && rinfo[i].insn_set
+ 			  && GET_CODE (rinfo[i].insn_set) == INSN)
+ 			{
+ 			  if (find_regno_note (insn, REG_DEAD, i))
+ 			    {
+ 			      /* copy insn_set just prior to insn */
+ 			      do_correction (i, insn, dump_file);
+ 			    }
+ 			  else
+ 			    { /* A use that is not dead - stop.  */
+                               rinfo[i].insn_set = NULL;
+ 			    }
+ 
+ 			}
+ 		    }
+ 		  bzero (regs_in_body, cur_max_reg * sizeof (int));
+ 		}
+ 	      for (i = 0; i < cur_max_reg; i++)
+ 		{
+ 		  rinfo[i].copied_for_src = 0;
+ 		}
+ 	      if (GET_CODE (dest) == REG)
+ 		{
+ 		  for (i = 0; i < cur_max_reg; i++)
+ 		    {
+ 		      if (rinfo[i].insn_set
+ 			  && reg_overlap_mentioned_p (dest, SET_SRC (PATTERN (rinfo[i].insn_set)))
+ 			)
+ 			{	/* current value of reg dest overwritten */
+ 			  rinfo[i].insn_set = NULL;
+ 			}
+ 		    }
+ 		  if (reg_overlap_mentioned_p (dest, SET_SRC (PATTERN (insn))))
+ 		    {
+ 		      rinfo[REGNO (dest)].insn_set = NULL;
+ 		    }
+ 		  else
+ 		    {
+ 		      if ((GET_CODE (SET_SRC (PATTERN (insn))) == ASHIFT
+ 		           && GET_CODE (XEXP (SET_SRC (PATTERN (insn)), 0)) == REG
+ 			   && GET_CODE (XEXP (SET_SRC (PATTERN (insn)), 1)) == CONST_INT)
+ 			  || (GET_CODE (SET_SRC (PATTERN (insn))) == PLUS
+ 		              && GET_CODE (XEXP (SET_SRC (PATTERN (insn)), 0)) == REG
+ 			      && GET_CODE (XEXP (SET_SRC (PATTERN (insn)), 1)) == SYMBOL_REF)
+ 			  || (GET_CODE (SET_SRC (PATTERN (insn))) == PLUS
+ 			      && GET_CODE (XEXP (SET_SRC (PATTERN (insn)), 0)) == MULT
+ 			      && GET_CODE (XEXP (XEXP (SET_SRC (PATTERN (insn)), 0), 0)) == REG
+ 			      && GET_CODE (XEXP (XEXP (SET_SRC (PATTERN (insn)), 0), 1)) == CONST_INT
+ 			      && GET_CODE (XEXP (SET_SRC (PATTERN (insn)), 1)) == CONST_INT)
+ 			  || (GET_CODE (SET_SRC (PATTERN (insn))) == PLUS
+ 		              && GET_CODE (XEXP (SET_SRC (PATTERN (insn)), 0)) == REG
+ 			      && GET_CODE (XEXP (SET_SRC (PATTERN (insn)), 1)) == CONST_INT)
+ 			)
+ 			{	/* these may be combinable */
+ 			  if (REG_NOTES (insn) == NULL)
+ 			    { /* Don't want to mess around with
+ 			         the REG_NOTES.  */
+ 			      rinfo[REGNO (dest)].insn_set = insn;
+ 			    }
+ 			}
+ 		      else
+ 			{
+ 			  rinfo[REGNO (dest)].insn_set = NULL;
+ 			}
+ 		    }
+ 		}
+ 	    }
+ 	  else if (GET_CODE (PATTERN (insn)) == USE)
+ 	    ; /* nothing */
+ 	  else 
+ 	    {
+ 	      bzero (rinfo, cur_max_reg * sizeof (struct regopt_info));
+ 	    }
+ 	  /* A register that dies cannot be used further in a substitution.  */
+           for (note = REG_NOTES (insn); note; note = XEXP (note, 1))
+ 	    if (REG_NOTE_KIND (note) == REG_DEAD
+ 		&& GET_CODE (XEXP (note, 0)) == REG)
+ 	      {
+ 		for (i = 0; i < cur_max_reg; i++)
+ 		  {
+ 		    if (rinfo[i].insn_set
+ 			&& reg_overlap_mentioned_p (XEXP (note, 0), 
+ 			      SET_SRC (PATTERN (rinfo[i].insn_set)))
+ 		       )
+ 		      {	
+ 			  rinfo[i].insn_set = NULL;
+ 	              }
+ 		  }    
+ 	      }
+ 
+ 	  break;
+ 
+ 	case JUMP_INSN:
+ 	case NOTE:
+ 	  break;
+ 
+ 	default:
+ 	  bzero (rinfo, cur_max_reg * sizeof (struct regopt_info));
+ 	  break;
+ 	}
+       insn = NEXT_INSN (insn);
+     }
+   for (i = 0; i < cur_max_reg; i++)
+     reg_n_sets[i] += my_reg_n_sets[i];
+ }
+ 
+ /*
+   Increment the reg_n_uses element for each register mentioned in body
+   and for each time it is mentioned
+ */
+ static void
+ count_reg_uses (body, where_to_count)
+      rtx body;
+      int *where_to_count;
+ {
+   int i, j, ret_val = 0;
+   char *fmt;
+   register RTX_CODE code = GET_CODE (body);
+ 
+   if (code == CLOBBER)
+     return;
+   else if (code == REG)
+     where_to_count[REGNO (body)]++;
+   else if (code == SET)
+     {
+       if (GET_CODE (SET_DEST (body)) != REG)
+ 	{
+ 	  count_reg_uses (SET_DEST (body), where_to_count);
+ 	}
+       count_reg_uses (SET_SRC (body), where_to_count);
+     }
+   else
+     {
+       fmt = GET_RTX_FORMAT (code);
+       for (i = GET_RTX_LENGTH (code) - 1; i >= 0; i--)
+ 	if (fmt[i] == 'e')
+ 	  count_reg_uses (XEXP (body, i), where_to_count);
+ 	else if (fmt[i] == 'E' || fmt[i] == 'V')
+ 	  {
+ 	    for (j = 0; j < XVECLEN (body, i); j++)
+ 	      count_reg_uses (XVECEXP (body, i, j), where_to_count);
+ 	  }
+     }
+ }
+ 
+ /*
+    Copy the insn that sets regnum to just before insn.
+    If that insn has been copied to in front of each of
+    it's uses then delete it
+ */
+ static void
+ do_correction (regnum, insn, dump_file)
+      int regnum;
+      rtx insn;
+      FILE * dump_file;
+ {
+   rtx insn_set;
+   int i;
+   
+   insn_set
+     = rinfo[regnum].insn_set;
+   if (BLOCK_NUM (insn) == BLOCK_NUM (insn_set))
+     { /* Since insn_set cannot be deleted stop optimization */
+       rinfo[regnum].insn_set = NULL;
+       return;
+     }
+   emit_insn_before (
+ 		     copy_rtx (PATTERN (insn_set)),
+ 		     insn);
+    
+   if (REG_NOTES (insn_set))
+     {
+       REG_NOTES (PREV_INSN (insn))
+ 	= copy_rtx (REG_NOTES (insn_set));
+     }
+   LOG_LINKS (insn)
+     = gen_rtx (INSN_LIST, VOIDmode, PREV_INSN (insn),
+ 	       LOG_LINKS (insn));
+   if (find_insn_list (insn_set,
+ 		      LOG_LINKS (insn)))
+     remove_dependence (insn, insn_set);
+   rinfo[regnum].num_uses_copied += regs_in_body[regnum];
+   my_reg_n_sets[regnum]++;
+   if (dump_file)
+     {
+       fprintf (dump_file,
+ 	       " copy insn %d to before insn %d\n",
+ 	       INSN_UID (insn_set), INSN_UID (insn));
+     }
+   if (rinfo[regnum].num_uses_copied == reg_n_uses[regnum])
+     {	/* insn_set is no longer relevant - delete it */
+       rinfo[regnum].insn_set = NULL;
+       PUT_CODE (insn_set, NOTE);
+       NOTE_LINE_NUMBER (insn_set) = NOTE_INSN_DELETED;
+       NOTE_SOURCE_FILE (insn_set) = 0;
+       if (dump_file)
+ 	{
+ 	  fprintf (dump_file,
+ 		   " delete insn %d \n",
+ 		   INSN_UID (insn_set));
+ 	}
+       reg_n_sets[regnum]--;
+     }
+   /* If insn was a basic block head then now the copy is
+      the basic block head.  */
+   for (i = 0; i < n_basic_blocks; i++)
+     {
+       if (basic_block_head[i] == insn)
+         {
+           basic_block_head[i] = PREV_INSN (insn);
+           break;
+         }
+     }
+   
+ }
+ 
+ /* intel2 */
+ /* Call flow_analysis without changing insns, and if save_pseudo is set, saves
+    the basic_block_live_at_start information, concerning the pseudo registers,
+    and restores it after flow_analysis. */
+ 
+ void
+ hard_reg_flow_analysis (f, file, save_pseudo)
+      rtx f;
+      FILE *file;
+      int save_pseudo;
+ {
+   int limit;
+   register int block, regno;
+ 
+   /* Element N is a regset describing the registers live
+      at the start of basic block N, as was saved before the call to
+      flow_analysis. We use it to restore the contents of the pseudo registers,
+      needed by other phases. */
+     
+   regset *basic_block_live_at_start_saved;
+     
+ #if 0
+   register int j;
+ #endif
+ 
+   if (save_pseudo)
+     {
+       int regset_size = ((max_regno + REGSET_ELT_BITS - 1) / REGSET_ELT_BITS);
+       int regset_bytes = regset_size * sizeof (*(regset)0);
+       basic_block_live_at_start_saved =
+   			   (regset *) alloca (n_basic_blocks * sizeof (regset));
+       /* copy basic_block_live_at_start to basic_block_live_at_start_saved */
+       for (block = 0; block < n_basic_blocks; block++)
+         {
+           basic_block_live_at_start_saved[block] = (regset) alloca (regset_bytes);
+           bcopy (basic_block_live_at_start[block],
+     	         basic_block_live_at_start_saved[block],
+     	         regset_bytes);
+         }
+ 
+ #if 0
+       /* Check if copy is o.k. */
+       if (file)
+         {
+           fprintf (file, "Pseudo registers live at start:\n");
+ 
+           for (block = 0; block < n_basic_blocks; block++)
+ 	    {
+ 	      fprintf (file, "\nBlock no. %d original:", block);
+ 
+ 	      for (regno = FIRST_PSEUDO_REGISTER; regno < max_regno; regno++)
+ 	        {
+ 	          register int offset = regno / REGSET_ELT_BITS;
+ 	          register REGSET_ELT_TYPE bit
+ 	      		     = (REGSET_ELT_TYPE) 1 << (regno % REGSET_ELT_BITS);
+ 	          if ((basic_block_live_at_start_saved[block][offset] & bit)
+ 	              ^ (basic_block_live_at_start[block][offset] & bit))
+ 	            {
+ 		      fprintf (file, "\nERROR: differnt values in regsets!\n");
+ 		      fprintf (file,
+ 			       "original: %d, saved: %d\n",
+ 			       basic_block_live_at_start[block][offset],
+ 			       basic_block_live_at_start_saved[block][offset]);
+ 	              abort ();
+ 	            }
+ 	          if (basic_block_live_at_start[block][offset] & bit)
+ 	            fprintf (file, " %d", regno);
+ 	        }
+ 	      fprintf (file, "\nSaved:");
+ 	      for (regno = FIRST_PSEUDO_REGISTER; regno < max_regno; regno++)
+ 	        {
+ 	          register int offset = regno / REGSET_ELT_BITS;
+ 	          register REGSET_ELT_TYPE bit
+ 	      		     = (REGSET_ELT_TYPE) 1 << (regno % REGSET_ELT_BITS);
+ 
+ 	          if (basic_block_live_at_start_saved[block][offset] & bit)
+ 	            fprintf (file, " %d", regno);
+ 	        }
+ 	      fprintf (file, "\n");
+             }  /* for (block = 0; block < n_basic_blocks; block++) */
+         }  /* if (file) */
+ #endif
+     }  /* if (save_pseudo) */
+ 
+   limit = max_reg_num ();
+ 
+   /* Do control and data flow analysis, and write the results to the dump
+    * file, if dump wanted.
+    */
+   flow_analysis (f, limit, file, 0 /* do not allow a change to the insns */ );
+ 
+   if (save_pseudo)
+     {
+       /* restore the contents of pseudo registers if basic_block_live_at_start */
+       for (block = 0; block < n_basic_blocks; block++)
+         {
+           for (regno = FIRST_PSEUDO_REGISTER; regno < max_regno; regno++)
+             {
+               register int offset = regno / REGSET_ELT_BITS;
+               register REGSET_ELT_TYPE bit
+ 	      		     = (REGSET_ELT_TYPE) 1 << (regno % REGSET_ELT_BITS);
+ 
+ 	      if (basic_block_live_at_start_saved[block][offset] & bit)
+ 	        basic_block_live_at_start[block][offset] |= bit;
+ 	      else
+ 	        basic_block_live_at_start[block][offset] &= ~bit;
+             }
+         }
+ 
+ #if 0
+       /* Check if copy is o.k. */
+       if (file)
+         {
+           fprintf (file, "Pseudo registers live at start - restored :\n");
+ 
+           for (block = 0; block < n_basic_blocks; block++)
+ 	    {
+ 	      fprintf (file, "Block no. %d:", block);
+ 	      for (regno = FIRST_PSEUDO_REGISTER; regno < max_regno; regno++)
+ 	        {
+ 	          register int offset = regno / REGSET_ELT_BITS;
+ 	          register REGSET_ELT_TYPE bit
+ 	      		     = (REGSET_ELT_TYPE) 1 << (regno % REGSET_ELT_BITS);
+ 	          if (basic_block_live_at_start[block][offset] & bit)
+ 	            fprintf (file, " %d", regno);
+ 	        }
+ 	      fprintf (file, "\n");
+             }
+         }
+ #endif
+     }  /* if (save_pseudo) */
+ }  /* hard_reg_flow_analysis (f, file, save_pseudo) */
diff -rNci gcc-2.7.2/fold-const.c gcc-2.7.2p/fold-const.c
*** gcc-2.7.2/fold-const.c	Fri Sep 15 22:26:12 1995
--- gcc-2.7.2p/fold-const.c	Tue Jan 23 09:35:24 1996
***************
*** 3645,3651 ****
  	return fold (build (MINUS_EXPR, type, arg0, TREE_OPERAND (arg1, 0)));
        else if (! FLOAT_TYPE_P (type))
  	{
! 	  if (integer_zerop (arg1))
  	    return non_lvalue (convert (type, arg0));
  
  	  /* If we are adding two BIT_AND_EXPR's, both of which are and'ing
--- 3645,3656 ----
  	return fold (build (MINUS_EXPR, type, arg0, TREE_OPERAND (arg1, 0)));
        else if (! FLOAT_TYPE_P (type))
  	{
! 	  if (integer_zerop (arg1)
! 	      /* intel1 if it is pointer_type then removing the + 0 here
! 	         will cause references to array[0] not to be marked
! 	         as MEM_IN_STRUCT_P.  So just leave the + 0 here - it
! 	         will be removed when the tree is made into rtl anyway.  */
! 	      && TREE_CODE (TREE_TYPE (arg0)) != POINTER_TYPE)
  	    return non_lvalue (convert (type, arg0));
  
  	  /* If we are adding two BIT_AND_EXPR's, both of which are and'ing
***************
*** 4010,4015 ****
--- 4015,4045 ----
      case FLOOR_DIV_EXPR:
      case CEIL_DIV_EXPR:
      case EXACT_DIV_EXPR:
+    /* intel1 - implemet x/C where c is floating point and a power of two
+               as x*(1/C)
+    */
+ #ifndef REAL_IS_NOT_DOUBLE
+       if (HOST_FLOAT_FORMAT == TARGET_FLOAT_FORMAT
+          && TREE_CODE (t) == RDIV_EXPR
+          && TREE_CODE (TREE_TYPE (t)) == REAL_TYPE
+          && TYPE_NAME (TREE_TYPE (t))
+          && TREE_CODE (TYPE_NAME TREE_TYPE (t)) == TYPE_DECL
+          && TREE_CODE (TREE_OPERAND (t,  1)) == REAL_CST
+          && TREE_CODE (TREE_TYPE (TREE_OPERAND (t, 1))) == REAL_TYPE
+          && TYPE_NAME (TREE_TYPE (TREE_OPERAND (t, 1)))
+          && TREE_CODE (TYPE_NAME (TREE_TYPE (TREE_OPERAND(t, 1))))== TYPE_DE CL
+          && TREE_REAL_CST (TREE_OPERAND (t, 1)) >= 2.0
+          && TREE_REAL_CST (TREE_OPERAND (t, 1))
+           ==(double)(REAL_VALUE_UNSIGNED_FIX(TREE_REAL_CST(TREE_OPERAND(t, 1))))
+           &&exact_log2(REAL_VALUE_UNSIGNED_FIX(TREE_REAL_CST(TREE_OPERAND(t,1)))) != -1
+          )
+         {
+           TREE_SET_CODE (t, MULT_EXPR);
+           code = TREE_CODE (t);
+           TREE_REAL_CST (TREE_OPERAND (t, 1))
+             = 1.0 / TREE_REAL_CST (TREE_OPERAND (t, 1));
+         }
+ #endif
        if (integer_onep (arg1))
  	return non_lvalue (convert (type, arg0));
        if (integer_zerop (arg1))
diff -rNci gcc-2.7.2/jump.c gcc-2.7.2p/jump.c
*** gcc-2.7.2/jump.c	Thu Oct 26 11:27:39 1995
--- gcc-2.7.2p/jump.c	Tue Jan 23 09:35:27 1996
***************
*** 1920,1926 ****
  
  	      /* First, cross jumping of conditional jumps:  */
  
! 	      if (cross_jump && condjump_p (insn))
  		{
  		  rtx newjpos, newlpos;
  		  rtx x = prev_real_insn (JUMP_LABEL (insn));
--- 1920,1935 ----
  
  	      /* First, cross jumping of conditional jumps:  */
  
! 	      if (cross_jump && condjump_p (insn)
! 	      /* intel1 */
! #ifdef NO_CROSS_JUMP_ON_LOOP_ENTRY
!                   && !(GET_CODE (NEXT_INSN(insn)) == NOTE
! 	               && 
! 	               (NOTE_LINE_NUMBER (NEXT_INSN(insn)) == NOTE_INSN_LOOP_BEG 
! 	                || NOTE_LINE_NUMBER (NEXT_INSN(insn)) == NOTE_INSN_LOOP_END)
! 	              )
! #endif
! 	         )
  		{
  		  rtx newjpos, newlpos;
  		  rtx x = prev_real_insn (JUMP_LABEL (insn));
